<?php
/**
 * settings_adstxt.php
 *
 * @version 1.0
 * @date 6/11/20 9:19 PM
 * @package wordpress-base
 */
if(!class_exists('WPeMatico_Adstxt')) :

	class WPeMatico_Adstxt {

		public static function hooks() {
			add_action('wpematico_settings_tab_settings', array(__CLASS__, 'settings_form'));
			add_action('admin_post_save_wpematico_settings', array(__CLASS__, 'settings_save'));
			add_action('admin_init', array(__CLASS__, 'settings_adstxt'));
		}

		public static function settings_adstxt() {
			if(( isset($_GET['page']) && $_GET['page'] == 'wpematico_settings' ) &&
				( isset($_GET['post_type']) && $_GET['post_type'] == 'wpematico' ) &&
				( (isset($_GET['tab']) && $_GET['tab'] == 'adstxt' ) || !isset($_GET['tab']) )
			) {
				$screen = WP_Screen::get('wpematico_page_wpematico_settings ');
				foreach(wpematico_helpsettings() as $key => $section) {
					$tabcontent = '';
					foreach($section as $section_key => $sdata) {
						$helptip[$section_key]	 = htmlentities($sdata['tip']);
						$tabcontent				 .= '<p><strong>' . $sdata['title'] . '</strong><br />' .
							$sdata['tip'] . '</p>';
						$tabcontent				 .= (isset($sdata['plustip'])) ? '<p style="margin-top: 2px;margin-left: 7px;">' . $sdata['plustip'] . '</p>' : '';
					}
					$screen->add_help_tab(array(
						'id'		 => $key,
						'title'		 => $key,
						'content'	 => $tabcontent,
					));
				}
			}
		}

		public static function settings_save() {
			if('POST' === $_SERVER['REQUEST_METHOD']) {
				if(!is_user_logged_in())
					wp_die("<h3>Cheatin' uh?</h3>", "Closed today.");

				check_admin_referer('wpematico-settings');
				$errlev = error_reporting();
				error_reporting(E_ALL & ~E_NOTICE);  // deactive notices by _POST vars

				/**
				 * wpematico_check_options Filter to sanitize and strip all options fields
				 */
				$cfg = apply_filters('wpematico_check_options', $_POST);
				if(!wpematico_is_pro_active())
					$cfg['nonstatic']	 = false;
				else
					$cfg['nonstatic']	 = true;
				wp_get_current_user();

				wp_clear_scheduled_hook('wpematico_cron');
				if(isset($cfg['disablewpcron']) && $cfg['disablewpcron']) {
					define('DISABLE_WP_CRON', true);
				}
				if(isset($cfg['enable_alternate_wp_cron']) && $cfg['enable_alternate_wp_cron']) {
					if(!defined('ALTERNATE_WP_CRON')) {
						define('ALTERNATE_WP_CRON', true);
					}
				}

				if(!(isset($cfg['dontruncron']) && $cfg['dontruncron'] )) {
					wp_schedule_event(time(), 'wpematico_int', 'wpematico_cron');
				}

				if(update_option(WPeMatico::OPTION_KEY, $cfg)) {
					WPeMatico::add_wp_notice(array('text' => __('Settings saved.', 'wpematico'), 'below-h2' => false));
				}
				error_reporting($errlev);
				wp_redirect(admin_url('edit.php?post_type=wpematico&page=wpematico_settings&tab=adstxt'));
			}
		}

		public static function settings_form() {
			global $cfg, $current_screen, $helptip;
			if(!isset($current_screen))
				wp_die("Cheatin' uh?", "Closed today.");
			$cfg = get_option(WPeMatico :: OPTION_KEY);
			$cfg = apply_filters('wpematico_check_options', $cfg);

			$helptip = wpematico_helpsettings('tips');
			?>
			<div class="wrap">

				<?php
				$ads_content = @file_get_contents( get_home_url() .'/ads.txt' );
				$exists = $ads_content ? true : false;

				$writeable = $exists && is_writable( get_home_path() .'ads.txt' );
				if( !$exists )
				{
					echo '<div id="setting-error-adtxt" class="notice notice-warning settings-error is-dismissible"><p><strong><span style="display: block; margin: 0.5em 0.5em 0 0; clear: both;">The plugin has not detected an ads.txt file on your server. You can check to see if it is loading by clicking <a href="/ads.txt" target="_blank">here</a>. If nothing loads, you can download and install the <a href="/wp-admin/plugin-install.php?s=ads+txt+10up&tab=search&type=term" target="_blank">Ads Manager</a> plugin to input your ads.txt code. If the code loads, or you use another ad code manager like <a href="https://ajdg.solutions/blog/adrotate-pro-5-3-important-update-for-security-and-ads-txt/" target="_blank">AdRotate Pro</a>, you can dismiss this message.</span></p></div>';
				}
				?>
				<h2><?php _e('Settings', 'wpematico'); ?></h2>
				<form action="<?php echo admin_url('admin-post.php'); ?>" name="wpematico-settings" method="post" autocomplete="off">
					<?php
					wp_nonce_field('wpematico-settings');
					/* Used to save closed meta boxes and their order */
					wp_nonce_field('meta-box-order', 'meta-box-order-nonce', false);
					wp_nonce_field('closedpostboxes', 'closedpostboxesnonce', false);
					?>
					<div id="poststuff">
						<div id="post-body" class="metabox-holder columns-<?php echo 1 == get_current_screen()->get_columns() ? '1' : '2'; ?>">
							<div id="post-body-content">
								<!-- #post-body-content -->
								<textarea name="content" rows="30" cols="100%"><?php echo ( $ads_content ); ?></textarea>
							</div>


							<div>
								<p>
									<?php submit_button(__('Save Ads.txt', 'wpematico'), 'primary', 'wpematico-save-settings2', false); ?>
								</p>
							</div>
						</div> <!-- #post-body -->
					</div> <!-- #poststuff -->
				</form>
			</div><!-- .wrap -->
			<?php
		}

	}

endif;
WPeMatico_Adstxt::hooks();